/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the StateUpdateRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &StateUpdateRequest{}

// StateUpdateRequest struct for StateUpdateRequest
type StateUpdateRequest struct {
	State State `json:"state"`
}

// NewStateUpdateRequest instantiates a new StateUpdateRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewStateUpdateRequest(state State) *StateUpdateRequest {
	this := StateUpdateRequest{}
	this.State = state
	return &this
}

// NewStateUpdateRequestWithDefaults instantiates a new StateUpdateRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewStateUpdateRequestWithDefaults() *StateUpdateRequest {
	this := StateUpdateRequest{}
	return &this
}

// GetState returns the State field value
func (o *StateUpdateRequest) GetState() State {
	if o == nil {
		var ret State
		return ret
	}

	return o.State
}

// GetStateOk returns a tuple with the State field value
// and a boolean to check if the value has been set.
func (o *StateUpdateRequest) GetStateOk() (*State, bool) {
	if o == nil {
		return nil, false
	}
	return &o.State, true
}

// SetState sets field value
func (o *StateUpdateRequest) SetState(v State) {
	o.State = v
}

func (o StateUpdateRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o StateUpdateRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["state"] = o.State
	return toSerialize, nil
}

type NullableStateUpdateRequest struct {
	value *StateUpdateRequest
	isSet bool
}

func (v NullableStateUpdateRequest) Get() *StateUpdateRequest {
	return v.value
}

func (v *NullableStateUpdateRequest) Set(val *StateUpdateRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableStateUpdateRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableStateUpdateRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableStateUpdateRequest(val *StateUpdateRequest) *NullableStateUpdateRequest {
	return &NullableStateUpdateRequest{value: val, isSet: true}
}

func (v NullableStateUpdateRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableStateUpdateRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


